//+------------------------------------------------------------------+
//|                                 lukas1 arrows & curves.mq4 v.28 
//|   Copyright  2007,    aka lukas1
//+------------------------------------------------------------------+
//1.    ,     ("relay")
//2.  ,   
//3.          

#property copyright "Copyright  2007,  "
#property link      "lukas1@ngs.ru"
//----
#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 DeepSkyBlue
#property indicator_color2 Red
#property indicator_color3 Orange
#property indicator_color4 Orange
#property indicator_color5 MediumSeaGreen
#property indicator_color6 MediumSeaGreen
#property indicator_color7 DeepSkyBlue
#property indicator_color8 Red
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width7 2
#property indicator_width8 2
//---- input parameters
extern int SSP=20;   //   
extern int Channel=0;    //  . ..   0-50
extern int Ch_Stop=30;   //   (  )
extern int relay=1;   //     4  
extern int CBars=2000; //  
double val1[], val2[], valX1[], valX2[];//     
double BufferH[], BufferL[], BufferHS[], BufferLS[];
//+------------------------------------------------------------------+
int init()
{
	SetIndexStyle(0, DRAW_ARROW,0,1); SetIndexArrow(0, 233); SetIndexBuffer(0, val1); SetIndexLabel(0, "BUY"); //   
	SetIndexStyle(1, DRAW_ARROW,0,1); SetIndexArrow(1, 234); SetIndexBuffer(1, val2); SetIndexLabel(1, "SELL"); //   
	SetIndexStyle(2, DRAW_LINE,0,1); SetIndexBuffer(2, BufferH); SetIndexLabel(2, "BUY from here");
	SetIndexStyle(3, DRAW_LINE,0,1); SetIndexBuffer(3, BufferL); SetIndexLabel(3, "SELL from here");
	SetIndexStyle(4, DRAW_LINE,0,1); SetIndexBuffer(4, BufferHS); SetIndexLabel(4, "BuyStop");
	SetIndexStyle(5, DRAW_LINE,0,1); SetIndexBuffer(5, BufferLS); SetIndexLabel(5, "SellStop");
	SetIndexStyle(6, DRAW_ARROW,0,2); SetIndexArrow(6, 251);  SetIndexBuffer(6, valX1); //  
	SetIndexStyle(7, DRAW_ARROW,0,2); SetIndexArrow(7, 251); SetIndexBuffer(7, valX2); //  
	for (int i=0; i<8; i++) SetIndexDrawBegin(i, Bars-CBars-2*SSP);
	return(0);
}
//+------------------------------------------------------------------+
int start()
{   
	int counted_bars=IndicatorCounted(); if(counted_bars>0) counted_bars--; 
	if(Bars<=SSP+1) return(0);
	double high, low, smin, smax, smin2, smax2;
	bool uptrend=false, old=false, uptrend2=false, old2=false;
	for(int i=CBars-SSP; i>=0; i--)
	{
		high=High[iHighest(Symbol(),0,MODE_HIGH,SSP,i+relay)]; 
		low=Low[iLowest(Symbol(),0,MODE_LOW,SSP,i+relay)]; 
		smax=high-(high-low)*Channel/100; // smax  high   .Channel
		smin=low+(high-low)*Channel/100; // smin  low   .Channel
		smax2=high-(high-low)*(Channel+Ch_Stop)/100; // smax  high   .Chan+Ch_Stop
		smin2=low+(high-low)*(Channel+Ch_Stop)/100;  // smin  low   .Channel
		BufferH[i]=smax; BufferL[i]=smin; BufferHS[i]=smax2; BufferLS[i]=smin2;
		//  
		val1[i]=0; val2[i]=0; valX1[i]=0; valX2[i]=0;
		if(Close[i]<smin && Close[i]<smax && uptrend2 && i!=0)	uptrend=false;
		if(Close[i]>smax && Close[i]>smin && !uptrend2 && i!=0) uptrend=true;
		if((Close[i]>smax2 || Close[i]>smin2) && !uptrend && i!=0) uptrend2=false;
		if((Close[i]<smin2 || Close[i]<smax2) && uptrend && i!=0 ) uptrend2=true; 
		if(Close[i]<smin && Close[i]<smax && !uptrend2 && i!=0) { val2[i]=low; uptrend2=true; } //  
		if(Close[i]>smax && Close[i]>smin && uptrend2&& i!=0) { val1[i]=high; uptrend2=false; } //  
		if(uptrend!=old && !uptrend) val2[i]=low; //  
		if(uptrend!=old && uptrend) val1[i]=high; //  
		if(uptrend2!=old2 && uptrend2) valX1[i]=smax2; //  
		if(uptrend2!=old2 && !uptrend2) valX2[i]=smin2; //  
		old=uptrend; old2=uptrend2;
	}
	return(0);
}

